useeol=true
if useeol then useeol=love.filesystem.isDirectory("engineoflove") end
if useeol then require "engineoflove" end

function love.load()
    field = {}
    field.xmargin=10
    field.ymargin=0

    game           = {}
    game.click     = 0.75
    game.dropclick = 0.05

    grid = {
        { -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1 },
        { -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1 },
        { -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1 },
        { -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1 },
        { -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1 },
        { -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1 },
        { -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1 },
        { -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1 },
        { -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1 },
        { -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1 },
        { -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1 },
        { -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1 },
        { -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1 },
        { -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1 },
        { -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1 },
        { -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1 },
        { -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1 },
        { -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1 },
        { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 },
    }

    piece = {
        {
            n    = "i",
            c    = {r=0, g=255, b=255 },
            hoff = -1,
            voff = -1,
            b000 = {
                { false, false, false, false },
                { true,  true,  true,  true  },
                { false, false, false, false },
                { false, false, false, false }
            },
            b090 = {
                { false, true,  false, false },
                { false, true,  false, false },
                { false, true,  false, false },
                { false, true,  false, false }
            },
            b180 = {
                { false, false, false, false },
                { true,  true,  true,  true  },
                { false, false, false, false },
                { false, false, false, false }
            },
            b270 = {
                { false, true,  false, false },
                { false, true,  false, false },
                { false, true,  false, false },
                { false, true,  false, false }
            }
        },
        {
            n    = "j",
            c    = {r=0, g=0, b=255 },
            hoff = -1,
            voff = -1,
            b000 = {
                { false, false, false, false },
                { true,  false, false, false },
                { true,  true,  true,  false },
                { false, false, false, false }
            },
            b090 = {
                { true,  true,  false, false },
                { true,  false, false, false },
                { true,  false, false, false },
                { false, false, false, false }
            },
            b180 = {
                { true,  true,  true,  false },
                { false, false, true,  false },
                { false, false, false, false },
                { false, false, false, false }
            },
            b270 = {
                { false, false, true,  false },
                { false, false, true,  false },
                { false, true,  true,  false },
                { false, false, false, false }
            }
        },
        {
            n    = "l",
            c    = {r=255, g=127, b=0 },
            hoff = -1,
            voff = -1,
            b000 = {
                { false, false, false, false },
                { false, false, true,  false },
                { true,  true,  true,  false },
                { false, false, false, false }
            },
            b090 = {
                { true,  false, false, false },
                { true,  false, false, false },
                { true,  true,  false, false },
                { false, false, false, false }
            },
            b180 = {
                { true,  true,  true,  false },
                { true,  false, false, false },
                { false, false, false, false },
                { false, false, false, false }
            },
            b270 = {
                { true,  true,  false, false },
                { false, true,  false, false },
                { false, true,  false, false },
                { false, false, false, false }
            }
        },
        {
            n    = "o",
            c    = {r=255, g=255, b=0 },
            hoff = -1,
            voff = -1,
            b000 = {
                { false, false, false, false },
                { false, true,  true,  false },
                { false, true,  true,  false },
                { false, false, false, false }
            },
            b090 = {
                { false, false, false, false },
                { false, true,  true,  false },
                { false, true,  true,  false },
                { false, false, false, false }
            },
            b180 = {
                { false, false, false, false },
                { false, true,  true,  false },
                { false, true,  true,  false },
                { false, false, false, false }
            },
            b270 = {
                { false, false, false, false },
                { false, true,  true,  false },
                { false, true,  true,  false },
                { false, false, false, false }
            }
        },
        {
            n    = "s",
            c    = {r=0, g=255, b=0 },
            hoff = -1,
            voff = 0,
            b000 = {
                { false, true,  true,  false },
                { true,  true,  false, false },
                { false, false, false, false },
                { false, false, false, false }
            },
            b090 = {
                { true,  false, false, false },
                { true,  true,  false, false },
                { false, true,  false, false },
                { false, false, false, false }
            },
            b180 = {
                { false, true,  true,  false },
                { true,  true,  false, false },
                { false, false, false, false },
                { false, false, false, false }
            },
            b270 = {
                { true,  false, false, false },
                { true,  true,  false, false },
                { false, true,  false, false },
                { false, false, false, false }
            }
        },
        {
            n    = "t",
            c    = {r=127, g=0, b=127 },
            hoff = -1,
            voff = 0,
            b000 = {
                { false, true,  false, false },
                { true,  true,  true,  false },
                { false, false, false, false },
                { false, false, false, false }
            },
            b090 = {
                { false, true,  false, false },
                { false, true,  true,  false },
                { false, true,  false, false },
                { false, false, false, false }
            },
            b180 = {
                { true,  true,  true,  false },
                { false, true,  false, false },
                { false, false, false, false },
                { false, false, false, false }
            },
            b270 = {
                { false, true,  false, false },
                { true,  true,  false, false },
                { false, true,  false, false },
                { false, false, false, false }
            }
        },
        {
            n    = "z",
            c    = {r=255, g=0, b=0 },
            hoff = -1,
            voff = 0,
            b000 = {
                { true,  true,  false, false },
                { false, true,  true,  false },
                { false, false, false, false },
                { false, false, false, false }
            },
            b090 = {
                { false, true,  false, false },
                { true,  true,  false, false },
                { true,  false, false, false },
                { false, false, false, false }
            },
            b180 = {
                { true,  true,  false, false },
                { false, true,  true,  false },
                { false, false, false, false },
                { false, false, false, false }
            },
            b270 = {
                { false, true,  false, false },
                { true,  true,  false, false },
                { true,  false, false, false },
                { false, false, false, false }
            }
        }
    }

    nextPiece()

    if useeol then
        eol.debug.user = {
            { n="timer",     f=function() return timer-timer%0.1 end },
            { n="curpiece",  f=function() return curpiece end },
            { n="nextpiece", f=function() return nextpiece end },
            { n="piece_x",   f=function() return piece_x end },
            { n="piece_y",   f=function() return piece_y end },
            { n="piece_rot", f=function() return piece_rot end },
        }
    end
end

function nextPiece()
    -- transfer current piece to grid
    if curpiece then
        local _bm=piece[curpiece].b000
        if piece_rot==90 then _bm=piece[curpiece].b090
        elseif piece_rot==180 then _bm=piece[curpiece].b180
        elseif piece_rot==270 then _bm=piece[curpiece].b270 end

        for _v=1,#_bm do
            for _h=1,#_bm[_v] do
                if _bm[_v][_h] then grid[piece_y-2+_v][piece_x+_h]=curpiece end
            end
        end
    end

    -- choose next pieces
    curpiece=math.random(#piece)
    nextpiece=math.random(#piece)
    piece_x=5+piece[curpiece].hoff
    piece_y=1+piece[curpiece].voff
    piece_rot=0
    timer=0
    width=16
end

function love.update(_dt)
    local _click=game.click
    if love.keyboard.isDown("down") then _click=game.dropclick end

    timer=timer+_dt
    if timer>_click then
        piece_y=piece_y+1
        checkWalls()
        timer=0
    end
end

function love.draw()
    local _x,_y=0,0
    if useeol then 
        _x=eol.screen.ofs_x_nocan
        _y=eol.screen.ofs_y_nocan
    end

    -- draw grid
    for _v=1,#grid do
        for _h=1,#grid[_v] do
            local _p=grid[_v][_h]

            if grid[_v][_h]==-1 then
                love.graphics.setColor(127,127,127)
                love.graphics.rectangle("line",_x+((field.xmargin+_h)*width),_y+((field.ymargin+_v-1)*width),width,width)
            elseif grid[_v][_h]>0 then
                love.graphics.setColor(piece[_p].c.r,piece[_p].c.g,piece[_p].c.b)
                love.graphics.rectangle("line",_x+((field.xmargin+_h)*width),_y+((field.ymargin+_v-1)*width),width,width)
            end

        end
    end

    -- draw current piece
    love.graphics.setColor(piece[curpiece].c.r,piece[curpiece].c.g,piece[curpiece].c.b)
    local _bm=piece[curpiece].b000
    if piece_rot==90 then _bm=piece[curpiece].b090
    elseif piece_rot==180 then _bm=piece[curpiece].b180
    elseif piece_rot==270 then _bm=piece[curpiece].b270 end

    for _v=1,#_bm do
        for _h=1,#_bm[_v] do
            if _bm[_v][_h] then love.graphics.rectangle("line",_x+((field.xmargin+piece_x+_h)*width),_y+((field.ymargin+piece_y+_v-2)*width),width,width) end
        end
    end
end

function love.keypressed(_k)
    if _k=="left" then
        piece_x=piece_x-1
        checkWalls()
    elseif _k=="right" then
        piece_x=piece_x+1
        checkWalls()
    elseif _k==" " then
        piece_rot=piece_rot+90
        if piece_rot>=360 then piece_rot=0 end
        checkWalls()
    end
end

function checkWalls()
    local _bm=piece[curpiece].b000
    if piece_rot==90 then _bm=piece[curpiece].b090
    elseif piece_rot==180 then _bm=piece[curpiece].b180
    elseif piece_rot==270 then _bm=piece[curpiece].b270 end

    local _click=game.click
    if love.keyboard.isDown("down") then _click=game.dropclick end

    for _y=1,#_bm do
        for _x=1,#_bm[_y] do
            -- check horizontally
            if _bm[_y][_x] and piece_x+_x>11 then piece_x=piece_x-(piece_x+_x-11)
            elseif _bm[_y][_x] and piece_x+_x<2 then piece_x=piece_x-(piece_x+_x-2) end

            -- check vertically
            if _bm[_y][_x] and piece_y+_y>19 then
                if timer>_click then nextPiece()
                else piece_y=piece_y-(piece_y+_y-19) end
            elseif _bm[_y][_x] and piece_y+_y<2 then piece_y=piece_y-(piece_y+_y-2) end
        end
    end
end
